'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _connect = require('react-redux/lib/components/connect');

var _connect2 = _interopRequireDefault(_connect);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

var _compact = require('lodash/compact');

var _compact2 = _interopRequireDefault(_compact);

var _iteratee = require('lodash/iteratee');

var _iteratee2 = _interopRequireDefault(_iteratee);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function createErrorComponent(component, message, modelValue, key) {
  var messageString = typeof message === 'function' ? message(modelValue) : message;

  return _react2.default.createElement(component, { key: key }, messageString);
}

function mapErrorMessages(errors, messages, modelValue, component) {
  return (0, _compact2.default)((0, _map2.default)(errors, function (error, key) {
    var message = messages[key];

    if (error) {
      if (message) {
        return createErrorComponent(component, message, modelValue, key);
      } else if (typeof error === 'string') {
        return createErrorComponent(component, error, modelValue, key);
      } else if ((typeof error === 'undefined' ? 'undefined' : _typeof(error)) === 'object') {
        return mapErrorMessages(error, messages, modelValue, component);
      }
    }

    return false;
  })).reduce(function (a, b) {
    return a.concat(b);
  }, []);
}

function showErrors(field) {
  var show = arguments.length <= 1 || arguments[1] === undefined ? true : arguments[1];

  if (typeof show === 'function') {
    return show(field);
  }

  if (!(0, _isArray2.default)(show) && (typeof show === 'undefined' ? 'undefined' : _typeof(show)) !== 'object' && typeof show !== 'string') {
    return !!show;
  }

  return (0, _iteratee2.default)(show)(field);
}

var Errors = function (_Component) {
  _inherits(Errors, _Component);

  function Errors() {
    _classCallCheck(this, Errors);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Errors).apply(this, arguments));
  }

  _createClass(Errors, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(_ref) {
      var fieldValue = _ref.fieldValue;

      return fieldValue !== this.props.fieldValue;
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var
      // model,
      modelValue = _props.modelValue;
      var fieldValue = _props.fieldValue;
      var _props$fieldValue = _props.fieldValue;
      var valid = _props$fieldValue.valid;
      var errors = _props$fieldValue.errors;
      var messages = _props.messages;
      var show = _props.show;
      var wrapper = _props.wrapper;
      var component = _props.component;


      if (!showErrors(fieldValue, show)) {
        return null;
      }

      var errorMessages = valid ? null : mapErrorMessages(errors, messages, modelValue, component);

      return _react2.default.createElement(wrapper, this.props, errorMessages);
    }
  }]);

  return Errors;
}(_react.Component);

Errors.propTypes = {
  model: _react.PropTypes.string.isRequired,
  modelValue: _react.PropTypes.any,
  fieldValue: _react.PropTypes.object,
  messages: _react.PropTypes.object,
  show: _react.PropTypes.any,
  wrapper: _react.PropTypes.string,
  component: _react.PropTypes.string
};

Errors.defaultProps = {
  wrapper: 'div',
  component: 'span',
  messages: {},
  show: true
};

function selector(state, _ref2) {
  var model = _ref2.model;

  var fieldValue = (0, _utils.getFieldFromState)(state, model);

  return _extends({}, state, {
    modelValue: (0, _get3.default)(state, model),
    fieldValue: fieldValue
  });
}

exports.default = (0, _connect2.default)(selector)(Errors);