'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _connect = require('react-redux/lib/components/connect');

var _connect2 = _interopRequireDefault(_connect);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _mapValues = require('lodash/mapValues');

var _mapValues2 = _interopRequireDefault(_mapValues);

var _actions = require('../actions');

var _actions2 = _interopRequireDefault(_actions);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function dispatchValidCallback(modelValue, callback) {
  return callback ? function () {
    return callback(modelValue);
  } : undefined;
}

function dispatchInvalidCallback(model, dispatch) {
  return function () {
    return dispatch(_actions2.default.setSubmitFailed(model));
  };
}

var Form = function (_Component) {
  _inherits(Form, _Component);

  function Form(props) {
    _classCallCheck(this, Form);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Form).call(this, props));

    _this.handleSubmit = _this.handleSubmit.bind(_this);
    return _this;
  }

  _createClass(Form, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.validate(this.props, true);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var validateOn = this.props.validateOn;


      if (validateOn !== 'change') return;

      this.validate(nextProps);
    }
  }, {
    key: 'validate',
    value: function validate(nextProps) {
      var _this2 = this;

      var initial = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];
      var _props = this.props;
      var validators = _props.validators;
      var errors = _props.errors;
      var model = _props.model;
      var dispatch = _props.dispatch;

      /* eslint-disable consistent-return */

      (0, _mapValues2.default)(validators, function (validator, field) {
        var fieldModel = [model, field].join('.');
        var value = (0, _get3.default)(nextProps, fieldModel);

        if (!initial && value === (0, _get3.default)(_this2.props, fieldModel)) return;

        var fieldValidity = (0, _utils.getValidity)(validator, value);

        dispatch(_actions2.default.setValidity(fieldModel, fieldValidity));

        return fieldValidity;
      });

      (0, _mapValues2.default)(errors, function (errorValidator, field) {
        var fieldModel = [model, field].join('.');
        var value = (0, _get3.default)(nextProps, fieldModel);

        if (!initial && value === (0, _get3.default)(_this2.props, fieldModel)) return;

        var fieldErrors = (0, _utils.getValidity)(errorValidator, value);

        dispatch(_actions2.default.setValidity(fieldModel, fieldErrors, {
          errors: true
        }));

        return fieldErrors;
      });
      /* eslint-enable consistent-return */
    }
  }, {
    key: 'handleSubmit',
    value: function handleSubmit(e) {
      e.preventDefault();

      var _props2 = this.props;
      var model = _props2.model;
      var modelValue = _props2.modelValue;
      var formValue = _props2.formValue;
      var onSubmit = _props2.onSubmit;
      var dispatch = _props2.dispatch;
      var validators = _props2.validators;


      var formValid = formValue ? formValue.valid : true;

      if (!validators && onSubmit && formValid) {
        onSubmit(modelValue);

        return modelValue;
      }

      var validCallback = dispatchValidCallback(modelValue, onSubmit);
      var invalidCallback = dispatchInvalidCallback(model, dispatch);

      dispatch(_actions2.default.validateFields(model, validators, validCallback, invalidCallback));

      return modelValue;
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'form',
        _extends({}, this.props, {
          onSubmit: this.handleSubmit
        }),
        this.props.children
      );
    }
  }]);

  return Form;
}(_react.Component);

Form.propTypes = {
  validators: _react.PropTypes.object,
  errors: _react.PropTypes.object,
  validateOn: _react.PropTypes.oneOf(['change', 'submit']),
  model: _react.PropTypes.string.isRequired,
  modelValue: _react.PropTypes.any,
  formValue: _react.PropTypes.object,
  onSubmit: _react.PropTypes.func,
  dispatch: _react.PropTypes.func,
  children: _react.PropTypes.node
};

Form.defaultProps = {
  validateOn: 'change'
};

function selector(state, _ref) {
  var model = _ref.model;

  return _extends({}, state, {
    modelValue: (0, _get3.default)(state, model),
    formValue: (0, _utils.getForm)(state, model)
  });
}

exports.default = (0, _connect2.default)(selector)(Form);